Index: /trunk/SophyaPI/PIext/pihisto.cc
===================================================================
--- /trunk/SophyaPI/PIext/pihisto.cc	(revision 202)
+++ /trunk/SophyaPI/PIext/pihisto.cc	(revision 203)
@@ -42,4 +42,5 @@
   bool oktrace = false;
   if (!mHisto)  return;  
+
   if (mMrk != PI_NotDefMarker || mHisto->ClassId() == HProf::classId ) {
     // Marqeurs definis OU HBProf => marqueurs+Erreurs si il y en a
@@ -92,4 +93,5 @@
     }
   }
+  // A faire a la fin - DrawStats change l'attribut de ligne 
   DrawStats(g);
 }
@@ -99,5 +101,6 @@
 {
   if (!mHisto) return;
-  if (mLAtt == PI_NotDefLineAtt)  g->SelLine(PI_ThinLine);
+  //  if (mLAtt == PI_NotDefLineAtt)  g->SelLine(PI_ThinLine);
+  g->SelLine(PI_ThinLine);
   float cellHeight = (YMax() - YMin()) * 0.05;
   float cellWidth  = (XMax() - XMin()) * 0.23;
Index: /trunk/SophyaPI/PIext/pistdimgapp.cc
===================================================================
--- /trunk/SophyaPI/PIext/pistdimgapp.cc	(revision 202)
+++ /trunk/SophyaPI/PIext/pistdimgapp.cc	(revision 203)
@@ -188,4 +188,5 @@
 mCmapid = CMAP_OTHER;
 mZoom = 0;
+mAxesFlags = kBoxAxes | kExtTicks | kLabels;
 SaveGraphicAtt();
 
@@ -440,4 +441,6 @@
 scw->SetBinding(PIBK_elastic, PIBK_elastic, PIBK_elastic, PIBK_elastic);
 scw->SetUserData(NULL, flag);
+scw->SetAxesFlags(mAxesFlags);
+
 if (!h2d) scw->AddScDrawer(scd, true);
 else ((PIH2DWdg*)scw)->SetPIHisto((PIHisto2D*)scd);
@@ -1139,4 +1142,9 @@
   mZoom = zoom;
 }
+/* --Methode-- */
+void PIStdImgApp::SetAxesAtt(unsigned int axfl)
+{
+  mAxesFlags = axfl; 
+}
 
 /* --Methode-- */
@@ -1152,4 +1160,5 @@
   mSCmapid = mCmapid;
   mSZoom = mZoom;
+  mSAxesFlags = mAxesFlags;
 }
 
@@ -1166,3 +1175,4 @@
   mCmapid = mSCmapid;
   mZoom = mSZoom;
-}
+  mAxesFlags = mSAxesFlags;
+}
Index: /trunk/SophyaPI/PIext/pistdimgapp.h
===================================================================
--- /trunk/SophyaPI/PIext/pistdimgapp.h	(revision 202)
+++ /trunk/SophyaPI/PIext/pistdimgapp.h	(revision 203)
@@ -91,4 +91,5 @@
      void  SetColMapId(CMapId cid=CMAP_OTHER);
      void  SetZoomAtt(int zoom=0);
+     void  SetAxesAtt(unsigned int axfl=kBoxAxes | kExtTicks | kLabels);
 // Pour sauvegarder-restauration de  l'etat des attributs graphiques
      void  SaveGraphicAtt();   
@@ -156,4 +157,5 @@
     CMapId       mCmapid, mSCmapid;
     int 	 mZoom, mSZoom;
+    unsigned int mAxesFlags, mSAxesFlags;
 
     PIMessage mFCMsg;  // Message for processing FileOpen
Index: /trunk/SophyaPI/PIext/servnobjm.cc
===================================================================
--- /trunk/SophyaPI/PIext/servnobjm.cc	(revision 202)
+++ /trunk/SophyaPI/PIext/servnobjm.cc	(revision 203)
@@ -456,4 +456,7 @@
   it = GrAzoom.find(grt[k]);
   if (it != GrAzoom.end())  { mImgapp->SetZoomAtt( (*it).second.a1 );  fgsrgr = true; continue; }  
+  // Si c'est un attribut d'axe
+  it = GrAaxes.find(grt[k]);
+  if (it != GrAaxes.end())  { mImgapp->SetAxesAtt( (*it).second.a1 );  fgsrgr = true; continue; }  
   
   }  
@@ -754,5 +757,5 @@
 GrAcmap["colbr128"] = gi;
 
-// Les tables de couleurs 
+// La valeur de zoom
 gi.a2 = 0;
 gi.a1 = 0;
@@ -776,4 +779,21 @@
 gi.a1 = -5;
 GrAzoom["zoom/5"] = gi;
-                 
-}
+
+// Attributs d'axes
+gi.a2 = 0;
+gi.a1 = (int)(kBoxAxes | kExtTicks | kLabels);
+GrAaxes["stdaxes"] = gi;
+GrAaxes["defaxes"] = gi;
+GrAaxes["boxaxes"] = gi;
+gi.a1 = (int)kAxesDflt;
+GrAaxes["simpleaxes"] = gi;
+gi.a1 = (int)(kBoxAxes | kExtTicks | kLabels | kGridOn);
+GrAaxes["boxaxesgrid"] = gi;
+
+gi.a1 = (int)(kBoxAxes | kTicks | kLabels | kMinTicks | kMajTicks);
+GrAaxes["fineaxes"] = gi;
+ gi.a1 = (int)(kBoxAxes | kTicks | kLabels | kMinTicks | kMajTicks | kGridOn);
+GrAaxes["grid"] = gi;
+GrAaxes["fineaxesgrid"] = gi;
+                
+}
Index: /trunk/SophyaPI/PIext/servnobjm.h
===================================================================
--- /trunk/SophyaPI/PIext/servnobjm.h	(revision 202)
+++ /trunk/SophyaPI/PIext/servnobjm.h	(revision 203)
@@ -57,4 +57,5 @@
   GrAttNames GrAcmap;  
   GrAttNames GrAzoom;  
+  GrAttNames GrAaxes;  
 
   PDynLinkMgr * dynlink;  // shared-lib lib.so