Index: /trunk/SophyaPI/PIext/pihisto2d.cc
===================================================================
--- /trunk/SophyaPI/PIext/pihisto2d.cc	(revision 212)
+++ /trunk/SophyaPI/PIext/pihisto2d.cc	(revision 213)
@@ -48,6 +48,11 @@
 void PIHisto2D::UseColors(bool fg, CMapId cmap)
 //
-//	Choix de la couleur si fg=true
+//	Choix de la couleur si fg=true avec la color map cmap.
 //	(pour la couleur cmap cf picmap.h).
+//      Independamment du choix du display, la dynamique est
+//      codee sur la color map donnant ainsi une double
+//      information. Par exemple, carres de tailles variables
+//      en couleur. Cette option est incontournable dans le cas
+//      d'un display par des carres de taille fixe.
 //--
 {
@@ -58,19 +63,19 @@
 void PIHisto2D::UseScale(unsigned short type,float logscale)
 //
-//	Pour changer les echelles.
+//	Pour changer les echelles (lineaire ou logarithmique)
 //| Type = 0 : echelle lineaire
 //|      = 1 : echelle log10
-//| - Explication du codage en type=1 (log10) :
-//|   1-/ map lineaire :
-//|       [0,1] -> [lmin,lmax]
-//|       f     -> F = lmin+f*(lmax-lmin)
-//|   2-/ transformation log10 :
-//|       [lmin,lmax] -> [log10(lmin),log10(lmax)]
-//|       F           -> LF = lg10(F)
-//|   3-/ rescaling entre 0 et 1 :
-//|       [log10(lmin),log10(lmax)] -> [0,1]
-//|       LF -> (LF-log10(lmin))/(log10(lmax)-log10(lmin))
-//|       soit en definissant logscale = lmax/lmin
-//|       LF = log10(1.+f*(logscale-1))/log10(logscale)
+//| -**- Explication du codage en type=0 (lineaire) :
+//|   1. [hmin,hmax] -> [0,1]
+//|           h      ->   f = (h-hmin)/(hmax-hmin)
+//|   2. codage de f=[0,1] sur la dynamique du display choisi
+//| -**- Explication du codage en type=1 (logarithmique base 10) :
+//|   1. map lineaire entre 0 et 1:
+//|      [hmin,hmax] -> [0,1]
+//|           h      ->   f = (h-hmin)/(hmax-hmin)
+//|   2. transformation logarithmique de base 10 :
+//|      [0,1] -> [0,1]
+//|        f   -> lf = log10(1.+f*(logscale-1))/log10(logscale)
+//|   3. codage de lf=[0,1] sur la dynamique du display choisi
 //--
 {
@@ -93,5 +98,5 @@
 //| Type = 2 : code a la "hbook2" " .+123...9AB...YZ*"
 //|            (cf detail PIHisto2D::HPrint2)
-//| Type = 3 : carres de tailles fixes (couleur).
+//| Type = 3 : carres de taille fixe (couleur).
 //--
 {
@@ -108,5 +113,10 @@
 //
 //	Gestion de la dynamique a representer:
-//	la dynamique va etre transformee de [hmin,hmax] vers [0,1].
+//|  La dynamique va etre transformee de [hmin,hmax] vers [0,1] selon
+//|  [hmin,hmax] -> [0,1]
+//|       h      ->   f = (h-hmin)/(hmax-hmin)
+//|  Par la suite selon ce qui est demande, f va coder le display ou etre
+//|  transforme en une autre echelle [0,1].
+//|  Si hmax<=hmin, ils sont forces a la dynamique totale de l'histo2D.
 //--
 {
@@ -121,6 +131,13 @@
 //	Pour definir la fraction de la dynamique a dessiner:
 //| Certains type de display (f=[0,1] cf PIHisto2D::UseDyn),
-//|    - on ne dessine rien si f <= frmin
-//|    - on limite l'excursion a f*frmax cad [...,frmax]
+//|  - on ne dessine rien si f <= frmin dans les cas de display avec
+//|    des nuages de points ou des carres de tailles variables.
+//|    Pour un display "a la hbook2" on force frmin = 0.
+//|  - frmax n'est utilise que pour la representation avec
+//|    des carres de tailles variables: c'est la taille
+//|    maximum que peut avoir le carre exprimee en unite
+//|    de la taille du bin (ex: si frmax=0.8 le carre
+//|    le + grand qui pourra etre dessine dans un bin
+//|    aura une taille egale a 0.8*(taille du bin)).
 //--
 {
@@ -160,4 +177,12 @@
 //
 //	Dessin de l'histogramme.
+//|  Code de dessin selon choix des options:
+//|  (detail voir UseColors UseScale UseDisplay UseDyn UseFrac)
+//|  [hmin,hmax] -> [0,1] [[ -> re-codage log10 entre [0,1] ]] -> f=[0,1]
+//|  Puis selon display:
+//|  0 carres variables : if(f>fracmin) taille carre = f*fracmax *taille_du_bin
+//|  1 nuage de points  : if(f>fracmin) npoints = f*PerPt *npoints_ecran_dans_bin
+//|  2 code hbook2      : if(f>0) map de f=]0,1] dans ".+...Z*"
+//|  3 carres fixes     : couleur = lut[f*nombre_d_entree_dans_la_lut]
 //--
 {