Index: trunk/SophyaLib/Mgr/Makefile
===================================================================
--- trunk/SophyaLib/Mgr/Makefile	(revision 220)
+++ trunk/SophyaLib/Mgr/Makefile	(revision 226)
@@ -1,49 +1,33 @@
 include Mgr/Makefile.h
-LIBF =  $(LIB)libOutils++.a $(LIB)libImages++.a $(LIB)libStarReco++.a $(LIB)libNeuralNet.a $(LIB)libAcq.a
-LIBS = -L$(LIB) -lOutils++ -lImages++ -lStarReco++ -lNeuralNet -lAcq -lm
-LIBG = -L$(GLB) -lg++ -lstdc++
+LIBF =  $(LIB)libSysTools.a $(LIB)libNTools.a $(LIB)libSamba.a
+LIBS = -L$(LIB) -lSysTools -lNTools -lSamba -lm
+LIBG = -L$(GLB) -lstdc++
 
-defaut: prog
+defaut: libs
 
-all: acq pi prog
+all: libs PI
 
-acq: ProgAcq
-pi:  ProgPI
-prog: Prog
 
-ProgAcq: Db++ Db Acq libs slb slbacq
-ProgPI:  PI libs slb slbpi
-Prog: libs slb
-
-libs: clibs cxxlibs
-clibs:
-	cd LibsUtil ; $(MAKE)
-	cd ImagFSuiv ; $(MAKE)
-	cd NR ; $(MAKE)
-
+libs: cxxlibs
 # Dans cet ordre pour les templates de cxx, a cause des dependances
 # pour instantiation automatique/manuels
 
-cxxlibs: NeuralNet Outils++ Images++ StarReco++ 
+cxxlibs: Blitz SysTools NTools Samba 
 
-.PHONY:  Acq
-Acq:
-	if [ -d Acq ] ; then cd  Acq ; $(MAKE) ; fi
+.PHONY:  Blitz
+Blitz:
+	if [ -d Blitz ] ; then cd  Blitz ; $(MAKE) ; fi
  
-.PHONY:  StarReco++
-StarReco++:
-	if [ -d StarReco++ ] ; then cd  StarReco++ ; $(MAKE) ; fi
+.PHONY:  SysTools
+SysTools:
+	if [ -d SysTools ] ; then cd  SysTools ; $(MAKE) ; fi
  
-.PHONY:  Images++
-Images++:
-	if [ -d Images++ ] ; then cd  Images++ ; $(MAKE) ; fi
+.PHONY:  NTools
+NTools:
+	if [ -d NTools ] ; then cd  NTools ; $(MAKE) ; fi
  
-.PHONY:  Outils++
-Outils++:
-	if [ -d Outils++ ] ; then cd  Outils++ ; $(MAKE) ; fi
- 
-.PHONY:  NeuralNet
-NeuralNet:
-	if [ -d NeuralNet ] ; then cd  NeuralNet ; $(MAKE) ; fi
+.PHONY:  Samba
+Samba:
+	if [ -d Samba ] ; then cd  Samba ; $(MAKE) ; fi
  
 .PHONY: PI
@@ -51,30 +35,10 @@
 	if [ -d PI ] ; then cd PI ; $(MAKE) ; fi
 	if [ -d PIext ] ; then cd PIext ; $(MAKE) ; fi
-.PHONY:  Db
-Db:
-	if [ -d Db ] ; then cd Db ; $(MAKE); fi
- 
-.PHONY:  Db++
-Db++:
-	if [ -d Db++ ] ; then cd Db++ ; $(MAKE); fi
- 
-.PHONY: Prog
-Prog:
-	if [ -d Prog ]; then cd  Prog ; $(MAKE); fi
- 
-.PHONY: ProgAcq
-ProgAcq:
-	if [ -d ProgAcq ]; then cd  ProgAcq ; $(MAKE); fi
- 
-.PHONY: ProgPI
-ProgPI:
-	if [ -d ProgPI ]; then cd  ProgPI ; $(MAKE); fi
- 
+
 ifndef NOSHLIB
 
-PSLB = $(LIB)libStarReco++.a $(LIB)libNeuralNet.a $(LIB)libImages++.a $(LIB)libOutils++.a
-slb : $(SLB)libnr.so $(SLB)liberosc.so $(SLB)libpeida.so
+PSLB = $(LIB)libSysTools.a $(LIB)libNTools.a $(LIB)libBlitz.a 
+slb : $(SLB)libtools.so
 slbpi: slb $(SLB)libPI.so
-slbacq: slb $(SLB)libAcq.so
 
 #  Commande de construction de shared-lib 
@@ -91,4 +55,6 @@
 CMDTILSHL := echo 'Cas Non Prevu'
 CMDTILSHLPI := echo 'Cas Non Prevu'
+#  Chemin des librairies Motifs / X11 (pour chemin non standard)
+LIBXPATH :=
 
 # Construction de shared-libs sous OSF1
@@ -116,43 +82,45 @@
   override FGSHLA := --whole-archive
   override FGSHLN := --no-whole-archiv
-  override LIBLSHL := $(LIBG) -lm -lc
+  override CMDSHLCXX := $(LINK.cc) -shared 
+  override FGSHLACXX := 
+  override FGSHLNCXX := 
+  override LIBLSHL := $(LIBG) -lm -ldl
   override TILSHL := 
   override CMDTILSHL := echo 'No Template instanciation library'
+  override LIBXPATH := -L/usr/X11/lib
 endif
 
+# Liste des .o associes a une librairie
+OBJSysTools = $(shell echo `cat ./SysTools/SysTools.o.list`)
+OBJNTools = $(shell echo `cat ./NTools/NTools.o.list`)
+OBJBlitz = $(shell echo `cat ./Blitz/Blitz.o.list`)
+OBJSamba = $(shell echo `cat ./Samba/Samba.o.list`)
+OBJPI         = $(shell echo `cat ./PI/PI.o.list`)
+OBJPIext      = $(shell echo `cat ./PIext/PIext.o.list`)
 
-$(SLB)libnr.so : $(LIB)libnra.a
-	$(CMDSHL) -o $(SLB)libnr.so \
-	$(FGSHLA) $(LIB)libnra.a \
-	$(FGSHLN) $(LIBLSHL)
+# Creation des librairies partagees
 
-$(SLB)liberosc.so : $(LIB)libdiv.a $(LIB)libmath.a \
-                    $(LIB)libfsv.a $(LIB)libimage.a
-	$(CMDSHL) -o $(SLB)liberosc.so \
-	$(FGSHLA) $(LIB)libdiv.a $(LIB)libmath.a \
-	$(LIB)libfsv.a $(LIB)libimage.a \
-	$(FGSHLN) $(LIBLSHL)
 
-$(SLB)libpeida.so : $(PSLB) $(SLB)liberosc.so $(SLB)libnr.so
+#------------------------------------------------------------
+$(SLB)libtools.so : $(PSLB) 
 	$(CMDTILSHL)
-	$(CMDSHL) -o $(SLB)libpeida.so \
-	$(FGSHLA) $(PSLB) $(TILSHL) \
-	$(FGSHLN) -L$(SLB) -lerosc -lnr $(LIBLSHL)
+	cd $(OBJ); \
+	$(CMDSHLCXX) -o $(SLB)libtools.so \
+	$(FGSHLACXX) $(OBJSysTools) $(OBJNTools) $(OBJSamba) $(OBJBlitz) $(TILSHL) \
+	$(FGSHLNCXX) -L$(SLB) $(LIBLSHL)
 
-$(SLB)libAcq.so : $(LIB)libAcq.a $(SLB)libpeida.so
-	$(CMDSHL) -o $(SLB)libAcq.so \
-	$(FGSHLA) $(LIB)libDb++.a $(LIB)libErosDb.a $(LIB)libAcq.a \
-	$(FGSHLN) -L$(SLB) -lpeida -lerosc -L$(ORACLE_HOME)/lib -lclntsh $(LIBLSHL)
 
-$(SLB)libPI.so : $(LIB)libPI.a $(LIB)libPIext.a  
+$(SLB)libPI.so : $(LIB)libPI.a $(LIB)libPIext.a
 	$(CMDTILSHLPI)
-	$(CMDSHL) -o $(SLB)libPI.so \
-	$(FGSHLA) $(LIB)libPI.a $(LIB)libPIext.a $(TILSHLPI) \
-	$(FGSHLN) -L$(SLB) -lpeida -lerosc \
-	-lXm -lXt -lX11 $(LIBLSHL)
+	cd $(OBJ); \
+	$(CMDSHLCXX) -o $(SLB)libPI.so \
+	$(FGSHLACXX) $(OBJPI) $(OBJPIext) $(TILSHLPI) \
+	$(FGSHLN) -L$(SLB) -ltools \
+	$(LIBXPATH) -lXm -lXt -lX11 $(LIBLSHL)
 
 else
 slb :
 endif
+
 
 clean:
@@ -161,8 +129,4 @@
 	if [ -d $(OBJ) ] ; then cd $(OBJ)/. ; rm -f *.o  ; fi
 	if [ -d $(OBJ)/cxxrep ] ; then cd $(OBJ)/cxxrep/. ; rm -f *.o  ; fi
-	if [ -d NR ]     ; then cd NR/.     ; make -f Makefile clean ; fi
 	if [ -d PI ]     ; then cd PI/.     ; $(MAKE) clean ; fi
-	if [ -d Prog ]   ; then cd Prog/.   ; $(MAKE) clean ; fi
-	if [ -d ProgPI ] ; then cd ProgPI/. ; $(MAKE) clean ; fi
-	if [ -d ProgAcq ]; then cd ProgAcq/.; $(MAKE) clean ; fi
 
Index: trunk/SophyaLib/Mgr/Makefile.slb
===================================================================
--- trunk/SophyaLib/Mgr/Makefile.slb	(revision 220)
+++ trunk/SophyaLib/Mgr/Makefile.slb	(revision 226)
@@ -59,4 +59,5 @@
 OBJNTools = $(shell echo `cat ./NTools/NTools.o.list`)
 OBJBlitz = $(shell echo `cat ./Blitz/Blitz.o.list`)
+OBJSamba = $(shell echo `cat ./Samba/Samba.o.list`)
 OBJPI         = $(shell echo `cat ./PI/PI.o.list`)
 OBJPIext      = $(shell echo `cat ./PIext/PIext.o.list`)
@@ -70,5 +71,5 @@
 	cd $(OBJ); \
 	$(CMDSHLCXX) -o $(SLB)libtools.so \
-	$(FGSHLACXX) $(OBJSysTools) $(OBJNTools) $(OBJBlitz) $(TILSHL) \
+	$(FGSHLACXX) $(OBJSysTools) $(OBJNTools) $(OBJSamba) $(OBJBlitz) $(TILSHL) \
 	$(FGSHLNCXX) -L$(SLB) $(LIBLSHL)
 
Index: trunk/SophyaLib/Mgr/libdirs
===================================================================
--- trunk/SophyaLib/Mgr/libdirs	(revision 220)
+++ trunk/SophyaLib/Mgr/libdirs	(revision 226)
@@ -1,2 +1,3 @@
 SysTools
 NTools
+Samba
Index: trunk/SophyaLib/Mgr/mkmf
===================================================================
--- trunk/SophyaLib/Mgr/mkmf	(revision 220)
+++ trunk/SophyaLib/Mgr/mkmf	(revision 226)
@@ -1,4 +1,4 @@
 #!/bin/csh 
-# $Id: mkmf,v 1.1.1.1 1999-04-09 17:55:32 ansari Exp $
+# $Id: mkmf,v 1.2 1999-04-13 15:11:11 ansari Exp $
 
 # creation de MakefileUser.h a partir de Makefile.h
@@ -30,5 +30,5 @@
 # pour instantiation automatique/manuels
 
-cxxlibs: Blitz SysTools NTools 
+cxxlibs: Blitz SysTools NTools Samba 
 
 EOF
@@ -36,5 +36,5 @@
 
 #  Attention, ne pas changer l'ordre de libnames dependances cxx
-set libnames = (Blitz SysTools NTools)
+set libnames = (Blitz SysTools NTools Samba)
 set i = 1
 set j = $#libnames ; @ j--
Index: trunk/SophyaLib/Mgr/ttsz.c
===================================================================
--- trunk/SophyaLib/Mgr/ttsz.c	(revision 226)
+++ trunk/SophyaLib/Mgr/ttsz.c	(revision 226)
@@ -0,0 +1,28 @@
+#include <stdio.h>
+
+/*  programme pour imprimer les tailles des types et le 
+    byte-swap                                            */
+
+main(int narg, char* arg)
+{
+int i,k;
+char* pc;
+
+printf(" Sizeof short int = %d \n", (int)(sizeof(short int)));
+printf(" Sizeof int = %d \n", (int)(sizeof(int)));
+printf(" Sizeof long = %d \n", (int)(sizeof(long)));
+printf(" Sizeof long long = %d \n", (int)(sizeof(long long)));
+printf(" Sizeof float = %d \n", (int)(sizeof(float)));
+printf(" Sizeof double = %d \n", (int)(sizeof(double)));
+printf(" Sizeof long double = %d \n", (int)(sizeof(long double)));
+
+
+i = 65;
+pc = (char *)(&i);
+for(k=0; k<4; k++)  { printf("I=%d  B%d = %d \n", i, k, (int)(*pc)); pc++; }
+i = 65*65536+16;
+pc = (char *)(&i);
+for(k=0; k<4; k++)  { printf("I=%d  B%d = %d \n", i, k, (int)(*pc)); pc++; }
+
+exit(0);
+}